Index: serefpolicy-contrib-20140730/rhcs.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rhcs.te
+++ serefpolicy-contrib-20140730/rhcs.te
@@ -1,4 +1,4 @@
-policy_module(rhcs, 1.3.1)
+policy_module(rhcs, 1.2.1)
 
 ########################################
 #
@@ -20,6 +20,35 @@ gen_tunable(fenced_can_network_connect,
 ## </desc>
 gen_tunable(fenced_can_ssh, false)
 
+## <desc>
+## <p>
+## Allow cluster administrative domains to connect to the network using TCP.
+## </p>
+## </desc>
+gen_tunable(cluster_can_network_connect, false)
+
+## <desc>
+## <p>
+## Allow cluster administrative domains to manage all files on a system.
+## </p>
+## </desc>
+gen_tunable(cluster_manage_all_files, false)
+
+## <desc>
+## <p>
+## Allow cluster administrative cluster domains memcheck-amd64- to use executable memory
+## </p>
+## </desc>
+gen_tunable(cluster_use_execmem, false)
+
+## <desc>
+##	<p>
+##	Determine whether haproxy can
+##	connect to all TCP ports.
+##	</p>
+## </desc>
+gen_tunable(haproxy_connect_any, false)
+
 attribute cluster_domain;
 attribute cluster_log;
 attribute cluster_pid;
@@ -44,34 +73,282 @@ type foghorn_initrc_exec_t;
 init_script_file(foghorn_initrc_exec_t)
 
 rhcs_domain_template(gfs_controld)
+rhcs_domain_template(haproxy)
+
+type haproxy_var_lib_t;
+files_type(haproxy_var_lib_t)
+
+type haproxy_unit_file_t;
+systemd_unit_file(haproxy_unit_file_t)
+
 rhcs_domain_template(groupd)
 rhcs_domain_template(qdiskd)
 
 type qdiskd_var_lib_t;
 files_type(qdiskd_var_lib_t)
 
+# cluster_t is a new domain for administrative generic cluster services 
+# (rgmanager, corosync, hearbeat, cman, pacemaker)
+rhcs_domain_template(cluster)
+
+typealias cluster_t alias { aisexec_t corosync_t pacemaker_t rgmanager_t };
+typealias cluster_exec_t alias { aisexec_exec_t corosync_exec_t pacemaker_exec_t rgmanager_exec_t };
+typealias cluster_tmpfs_t alias { aisexec_tmpfs_t corosync_tmpfs_t pacemaker_tmpfs_t rgmanager_tmpfs_t };
+typealias cluster_var_log_t alias { aisexec_var_log_t corosync_var_log_t rgmanager_var_log_t };
+typealias cluster_var_run_t alias { aisexec_var_run_t corosync_var_run_t pacemaker_var_run_t rgmanager_var_run_t };
+
+type cluster_initrc_exec_t;
+typealias cluster_initrc_exec_t alias { aisexec_initrc_exec_t corosync_initrc_exec_t pacemaker_initrc_exec_t rgmanager_initrc_exec_t };
+init_script_file(cluster_initrc_exec_t)
+
+type cluster_tmp_t;
+typealias cluster_tmp_t alias { aisexec_tmp_t corosync_tmp_t pacemaker_tmp_t rgmanager_tmp_t };
+files_tmp_file(cluster_tmp_t)
+
+type cluster_var_lib_t;
+typealias cluster_var_lib_t alias { aisexec_var_lib_t corosync_var_lib_t pacemaker_var_lib_t rgmanager_var_lib_t };
+files_type(cluster_var_lib_t)
+
+type cluster_unit_file_t;
+typealias cluster_unit_file_t alias { corosync_unit_file_t pacemaker_unit_file_t };
+systemd_unit_file(cluster_unit_file_t)
+
 #####################################
 #
 # Common cluster domains local policy
 #
 
 allow cluster_domain self:capability sys_nice;
-allow cluster_domain self:process setsched;
+allow cluster_domain self:process { signal setsched };
 allow cluster_domain self:sem create_sem_perms;
 allow cluster_domain self:fifo_file rw_fifo_file_perms;
 allow cluster_domain self:unix_stream_socket create_stream_socket_perms;
 allow cluster_domain self:unix_dgram_socket create_socket_perms;
 
-logging_send_syslog_msg(cluster_domain)
+manage_dirs_pattern(cluster_domain, cluster_log, cluster_log)
+manage_files_pattern(cluster_domain, cluster_log, cluster_log)
+manage_sock_files_pattern(cluster_domain, cluster_log, cluster_log)
 
-miscfiles_read_localization(cluster_domain)
+tunable_policy(`cluster_use_execmem',`
+    allow cluster_domain self:process execmem;
+')
 
 optional_policy(`
 	ccs_stream_connect(cluster_domain)
 ')
 
 optional_policy(`
-	corosync_stream_connect(cluster_domain)
+	dbus_system_bus_client(cluster_domain)
+')
+
+#####################################
+#
+# cluster domain local policy
+#
+
+allow cluster_t self:capability { dac_override fowner setuid setgid sys_nice sys_admin sys_resource ipc_lock ipc_owner };
+# for hearbeat
+allow cluster_t self:capability { net_raw chown };
+allow cluster_t self:capability2 block_suspend;
+allow cluster_t self:process { setpgid setrlimit setsched signull };
+
+allow cluster_t self:tcp_socket create_stream_socket_perms;
+allow cluster_t self:shm create_shm_perms;
+
+manage_dirs_pattern(cluster_t, cluster_tmp_t, cluster_tmp_t)
+manage_files_pattern(cluster_t, cluster_tmp_t, cluster_tmp_t)
+files_tmp_filetrans(cluster_t, cluster_tmp_t, { file dir })
+
+can_exec(cluster_t, cluster_var_lib_t)
+manage_files_pattern(cluster_t, cluster_var_lib_t,cluster_var_lib_t)
+manage_dirs_pattern(cluster_t, cluster_var_lib_t,cluster_var_lib_t)
+manage_sock_files_pattern(cluster_t, cluster_var_lib_t,cluster_var_lib_t)
+manage_fifo_files_pattern(cluster_t, cluster_var_lib_t,cluster_var_lib_t)
+files_var_lib_filetrans(cluster_t,cluster_var_lib_t, { file dir fifo_file sock_file })
+
+can_exec(cluster_t, cluster_exec_t)
+
+kernel_kill(cluster_t)
+kernel_read_all_sysctls(cluster_t)
+kernel_read_system_state(cluster_t)
+kernel_rw_rpc_sysctls(cluster_t)
+kernel_search_debugfs(cluster_t)
+kernel_search_network_state(cluster_t)
+
+corecmd_exec_bin(cluster_t)
+corecmd_exec_shell(cluster_t)
+
+corenet_all_recvfrom_unlabeled(cluster_t)
+corenet_all_recvfrom_netlabel(cluster_t)
+corenet_udp_sendrecv_generic_if(cluster_t)
+corenet_udp_sendrecv_generic_node(cluster_t)
+corenet_udp_bind_generic_node(cluster_t)
+
+corenet_sendrecv_netsupport_server_packets(cluster_t)
+corenet_udp_bind_netsupport_port(cluster_t)
+corenet_udp_sendrecv_netsupport_port(cluster_t)
+
+corenet_sendrecv_cluster_server_packets(cluster_t)
+corenet_udp_bind_cluster_port(cluster_t)
+corenet_udp_sendrecv_cluster_port(cluster_t)
+
+# need to write to /dev/misc/dlm-contro
+dev_rw_dlm_control(cluster_t)
+dev_setattr_dlm_control(cluster_t)
+dev_read_sysfs(cluster_t)
+dev_read_rand(cluster_t)
+dev_read_urand(cluster_t)
+
+domain_read_all_domains_state(cluster_t)
+
+fs_getattr_xattr_fs(cluster_t)
+fs_getattr_all_fs(cluster_t)
+
+storage_raw_read_fixed_disk(cluster_t)
+
+term_getattr_pty_fs(cluster_t)
+
+files_manage_mounttab(cluster_t)
+# needed by resources scripts
+files_read_non_security_files(cluster_t)
+auth_dontaudit_getattr_shadow(cluster_t)
+
+init_domtrans_script(cluster_t)
+init_initrc_domain(cluster_t)
+init_read_script_state(cluster_t)
+init_rw_script_tmp_files(cluster_t)
+init_manage_script_status_files(cluster_t)
+
+userdom_delete_user_tmp_files(cluster_t)
+userdom_rw_user_tmp_files(cluster_t)
+userdom_kill_all_users(cluster_t)
+
+tunable_policy(`cluster_can_network_connect',`
+    corenet_tcp_connect_all_ports(cluster_t)
+')
+
+# we need to have dirs created with var_run_t in /run/cluster
+files_create_var_run_dirs(cluster_t)
+
+tunable_policy(`cluster_manage_all_files',`
+	files_getattr_all_symlinks(cluster_t)
+	files_list_all(cluster_t)
+	files_manage_mnt_dirs(cluster_t)
+	files_manage_mnt_files(cluster_t)
+	files_manage_mnt_symlinks(cluster_t)
+	files_manage_isid_type_files(cluster_t)
+	files_manage_isid_type_dirs(cluster_t)
+	fs_manage_tmpfs_files(cluster_t)
+')
+
+optional_policy(`
+    ccs_read_config(cluster_t)
+')
+
+optional_policy(`
+    cmirrord_rw_shm(cluster_t)
+')
+
+optional_policy(`
+    consoletype_exec(cluster_t)
+')
+
+optional_policy(`
+    lvm_domtrans(cluster_t)
+	lvm_rw_clvmd_tmpfs_files(cluster_t)
+    lvm_delete_clvmd_tmpfs_files(cluster_t)
+')
+
+optional_policy(`
+    fstools_domtrans(cluster_t)
+')
+
+
+optional_policy(`
+    hostname_exec(cluster_t)
+')
+
+optional_policy(`
+    ccs_manage_config(cluster_t)
+    ccs_stream_connect(cluster_t)
+')
+
+optional_policy(`
+    ldap_systemctl(cluster_t)
+')
+
+optional_policy(`
+    mount_domtrans(cluster_t)
+')
+
+optional_policy(`
+    mysql_domtrans_mysql_safe(cluster_t)
+    mysql_stream_connect(cluster_t)
+')
+
+optional_policy(`
+    netutils_domtrans(cluster_t)
+    netutils_domtrans_ping(cluster_t)
+')
+
+optional_policy(`
+    postgresql_signal(cluster_t)
+')
+
+optional_policy(`
+	rhcs_getattr_fenced(cluster_t)
+	rhcs_rw_cluster_shm(cluster_t)
+    rhcs_rw_cluster_semaphores(cluster_t)
+    rhcs_stream_connect_cluster(cluster_t)
+    rhcs_relabel_cluster_lib_files(cluster_t)
+')
+
+optional_policy(`
+    rdisc_exec(cluster_t)
+')
+
+optional_policy(`
+    ricci_dontaudit_rw_modcluster_pipes(cluster_t)
+')
+
+optional_policy(`
+    rpc_systemctl_nfsd(cluster_t)
+    rpc_systemctl_rpcd(cluster_t)
+
+    rpc_domtrans_nfsd(cluster_t)
+    rpc_domtrans_rpcd(cluster_t)
+    rpc_manage_nfs_state_data(cluster_t)
+')
+
+optional_policy(`
+    samba_manage_var_files(cluster_t)
+    samba_rw_config(cluster_t)
+    samba_signal_smbd(cluster_t)
+    samba_signal_nmbd(cluster_t)
+')
+
+optional_policy(`
+    sysnet_domtrans_ifconfig(cluster_t)
+')
+
+optional_policy(`
+    udev_read_db(cluster_t)
+')
+
+optional_policy(`
+    virt_stream_connect(cluster_t)
+')
+
+optional_policy(`
+    unconfined_domain(cluster_t)
+')
+
+optional_policy(`
+    wdmd_rw_tmpfs(cluster_t)
+')
+
+optional_policy(`
+    xen_domtrans_xm(cluster_t)
 ')
 
 #####################################
@@ -79,9 +356,11 @@ optional_policy(`
 # dlm_controld local policy
 #
 
-allow dlm_controld_t self:capability { net_admin sys_admin sys_resource };
+allow dlm_controld_t self:capability { dac_override net_admin sys_admin sys_resource };
 allow dlm_controld_t self:netlink_kobject_uevent_socket create_socket_perms;
 
+files_pid_filetrans(dlm_controld_t, dlm_controld_var_run_t, dir)
+
 stream_connect_pattern(dlm_controld_t, fenced_var_run_t, fenced_var_run_t, fenced_t)
 stream_connect_pattern(dlm_controld_t, groupd_var_run_t, groupd_var_run_t, groupd_t)
 
@@ -98,16 +377,30 @@ fs_manage_configfs_dirs(dlm_controld_t)
 
 init_rw_script_tmp_files(dlm_controld_t)
 
+logging_send_syslog_msg(dlm_controld_t)
+
+optional_policy(`
+	rhcs_rw_cluster_tmpfs(dlm_controld_t)
+')
+
+optional_policy(`
+    rhcs_stream_connect_cluster(dlm_controld_t)
+')
+
 #######################################
 #
 # fenced local policy
 #
 
-allow fenced_t self:capability { sys_rawio sys_resource };
-allow fenced_t self:process { getsched signal_perms };
-allow fenced_t self:tcp_socket { accept listen };
+allow fenced_t self:capability { net_admin sys_rawio sys_resource };
+allow fenced_t self:process { getsched setpgid signal_perms };
+
+allow fenced_t self:tcp_socket create_stream_socket_perms;
+allow fenced_t self:udp_socket create_socket_perms;
 allow fenced_t self:unix_stream_socket connectto;
 
+can_exec(fenced_t, fenced_exec_t)
+
 manage_files_pattern(fenced_t, fenced_lock_t, fenced_lock_t)
 files_lock_filetrans(fenced_t, fenced_lock_t, file)
 
@@ -118,9 +411,8 @@ files_tmp_filetrans(fenced_t, fenced_tmp
 
 stream_connect_pattern(fenced_t, groupd_var_run_t, groupd_var_run_t, groupd_t)
 
-can_exec(fenced_t, fenced_exec_t)
-
 kernel_read_system_state(fenced_t)
+kernel_read_network_state(fenced_t)
 
 corecmd_exec_bin(fenced_t)
 corecmd_exec_shell(fenced_t)
@@ -140,6 +432,8 @@ corenet_udp_sendrecv_ionixnetmon_port(fe
 
 corenet_sendrecv_zented_server_packets(fenced_t)
 corenet_tcp_bind_zented_port(fenced_t)
+corenet_udp_bind_zented_port(fenced_t)
+corenet_tcp_connect_zented_port(fenced_t)
 corenet_tcp_sendrecv_zented_port(fenced_t)
 
 corenet_sendrecv_http_client_packets(fenced_t)
@@ -148,9 +442,7 @@ corenet_tcp_sendrecv_http_port(fenced_t)
 
 dev_read_sysfs(fenced_t)
 dev_read_urand(fenced_t)
-
-files_read_usr_files(fenced_t)
-files_read_usr_symlinks(fenced_t)
+dev_read_rand(fenced_t)
 
 storage_raw_read_fixed_disk(fenced_t)
 storage_raw_write_fixed_disk(fenced_t)
@@ -160,7 +452,7 @@ term_getattr_pty_fs(fenced_t)
 term_use_generic_ptys(fenced_t)
 term_use_ptmx(fenced_t)
 
-auth_use_nsswitch(fenced_t)
+logging_send_syslog_msg(fenced_t)
 
 tunable_policy(`fenced_can_network_connect',`
 	corenet_sendrecv_all_client_packets(fenced_t)
@@ -182,7 +474,8 @@ optional_policy(`
 ')
 
 optional_policy(`
-	corosync_exec(fenced_t)
+    rhcs_exec_cluster(fenced_t)
+    rhcs_rw_cluster_tmpfs(fenced_t)
 ')
 
 optional_policy(`
@@ -190,12 +483,12 @@ optional_policy(`
 ')
 
 optional_policy(`
-	gnome_read_generic_home_content(fenced_t)
+	lvm_domtrans(fenced_t)
+	lvm_read_config(fenced_t)
 ')
 
 optional_policy(`
-	lvm_domtrans(fenced_t)
-	lvm_read_config(fenced_t)
+    sanlock_domtrans(fenced_t)
 ')
 
 optional_policy(`
@@ -203,6 +496,13 @@ optional_policy(`
 	snmp_manage_var_lib_dirs(fenced_t)
 ')
 
+optional_policy(`
+	virt_domtrans(fenced_t)
+	virt_read_config(fenced_t)
+	virt_read_pid_files(fenced_t)
+	virt_stream_connect(fenced_t)
+')
+
 #######################################
 #
 # foghorn local policy
@@ -221,16 +521,18 @@ corenet_sendrecv_agentx_client_packets(f
 corenet_tcp_connect_agentx_port(foghorn_t)
 corenet_tcp_sendrecv_agentx_port(foghorn_t)
 
+corenet_tcp_connect_snmp_port(foghorn_t)
+
 dev_read_urand(foghorn_t)
 
-files_read_usr_files(foghorn_t)
+logging_send_syslog_msg(foghorn_t)
 
 optional_policy(`
 	dbus_connect_system_bus(foghorn_t)
 ')
 
 optional_policy(`
-	snmp_read_snmp_var_lib_files(foghorn_t)
+    snmp_manage_var_lib_files(foghorn_t)
 	snmp_stream_connect(foghorn_t)
 ')
 
@@ -257,6 +559,8 @@ storage_getattr_removable_dev(gfs_contro
 
 init_rw_script_tmp_files(gfs_controld_t)
 
+logging_send_syslog_msg(gfs_controld_t)
+
 optional_policy(`
 	lvm_exec(gfs_controld_t)
 	dev_rw_lvm_control(gfs_controld_t)
@@ -275,10 +579,54 @@ domtrans_pattern(groupd_t, fenced_exec_t
 
 dev_list_sysfs(groupd_t)
 
-files_read_etc_files(groupd_t)
-
 init_rw_script_tmp_files(groupd_t)
 
+logging_send_syslog_msg(groupd_t)
+
+########################################
+#
+# haproxy local policy
+#
+
+# bug in haproxy and process vs pid owner
+allow haproxy_t self:capability { dac_override kill };
+
+allow haproxy_t self:capability { chown setgid setuid sys_chroot sys_resource };
+allow haproxy_t self:capability2 block_suspend;
+allow haproxy_t self:process { fork setrlimit signal_perms };
+allow haproxy_t self:fifo_file rw_fifo_file_perms;
+allow haproxy_t self:unix_stream_socket create_stream_socket_perms;
+allow haproxy_t self:tcp_socket create_stream_socket_perms;
+allow haproxy_t self: udp_socket create_socket_perms;
+
+manage_dirs_pattern(haproxy_t, haproxy_var_lib_t, haproxy_var_lib_t)
+manage_files_pattern(haproxy_t, haproxy_var_lib_t, haproxy_var_lib_t)
+manage_lnk_files_pattern(haproxy_t, haproxy_var_lib_t, haproxy_var_lib_t)
+manage_sock_files_pattern(haproxy_t, haproxy_var_lib_t, haproxy_var_lib_t)
+files_var_lib_filetrans(haproxy_t, haproxy_var_lib_t, { dir file lnk_file })
+
+corenet_sendrecv_unlabeled_packets(haproxy_t)
+
+corenet_tcp_connect_commplex_link_port(haproxy_t)
+corenet_tcp_connect_commplex_main_port(haproxy_t)
+corenet_tcp_bind_commplex_main_port(haproxy_t)
+corenet_tcp_bind_http_port(haproxy_t)
+corenet_tcp_bind_http_cache_port(haproxy_t)
+
+corenet_tcp_connect_fmpro_internal_port(haproxy_t)
+corenet_tcp_connect_http_port(haproxy_t)
+corenet_tcp_connect_http_cache_port(haproxy_t)
+corenet_tcp_connect_rtp_media_port(haproxy_t)
+
+sysnet_dns_name_resolve(haproxy_t)
+
+tunable_policy(`haproxy_connect_any',`
+	corenet_tcp_connect_all_ports(haproxy_t)
+	corenet_tcp_bind_all_ports(haproxy_t)
+	corenet_sendrecv_all_packets(haproxy_t)
+	corenet_tcp_sendrecv_all_ports(haproxy_t)
+')
+
 ######################################
 #
 # qdiskd local policy
@@ -321,6 +669,8 @@ storage_raw_write_fixed_disk(qdiskd_t)
 
 auth_use_nsswitch(qdiskd_t)
 
+logging_send_syslog_msg(qdiskd_t)
+
 optional_policy(`
 	netutils_domtrans_ping(qdiskd_t)
 ')
Index: serefpolicy-contrib-20140730/rhev.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhev.fc
@@ -0,0 +1,13 @@
+/usr/share/rhev-agent/rhev-agentd\.py	--	gen_context(system_u:object_r:rhev_agentd_exec_t,s0)
+/usr/share/ovirt-guest-agent	--	 gen_context(system_u:object_r:rhev_agentd_exec_t,s0)
+
+/usr/share/rhev-agent/LockActiveSession\.py --  gen_context(system_u:object_r:rhev_agentd_exec_t,s0)
+/usr/share/ovirt-guest-agent/LockActiveSession\.py  --  gen_context(system_u:object_r:rhev_agentd_exec_t,s0)
+
+/usr/lib/systemd/system/ovirt-guest-agent.*  --              gen_context(system_u:object_r:rhev_agentd_unit_file_t,s0)
+
+/var/run/rhev-agentd\.pid		--	gen_context(system_u:object_r:rhev_agentd_var_run_t,s0)
+/var/run/ovirt-guest-agent\.pid --  gen_context(system_u:object_r:rhev_agentd_var_run_t,s0)
+
+/var/log/rhev-agent(/.*)?           gen_context(system_u:object_r:rhev_agentd_log_t,s0)
+/var/log/ovirt-guest-agent(/.*)?	gen_context(system_u:object_r:rhev_agentd_log_t,s0)
Index: serefpolicy-contrib-20140730/rhev.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhev.if
@@ -0,0 +1,76 @@
+## <summary>rhev polic module contains policies for rhev apps</summary>
+
+#####################################
+## <summary>
+##  Execute rhev-agentd in the rhev_agentd domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhev_domtrans_agentd',`
+    gen_require(`
+        type rhev_agentd_t, rhev_agentd_exec_t;
+    ')
+
+    domtrans_pattern($1, rhev_agentd_exec_t, rhev_agentd_t)
+')
+
+####################################
+## <summary>
+##  Read rhev-agentd PID files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`rhev_read_pid_files_agentd',`
+    gen_require(`
+        type rhev_agentd_var_run_t;
+    ')
+
+	files_search_pids($1)
+    read_files_pattern($1, rhev_agentd_var_run_t, rhev_agentd_var_run_t)
+')
+
+#####################################
+## <summary>
+##      Connect to rhev_agentd over a unix domain
+##      stream socket.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`rhev_stream_connect_agentd',`
+        gen_require(`
+                type rhev_agentd_var_run_t, rhev_agentd_t;
+        ')
+
+        files_search_pids($1)
+        stream_connect_pattern($1, rhev_agentd_var_run_t, rhev_agentd_var_run_t, rhev_agentd_t)
+')
+
+######################################
+## <summary>
+##  Send sigchld to rhev-agentd
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access
+##  </summary>
+## </param>
+#
+interface(`rhev_sigchld_agentd',`
+    gen_require(`
+              type rhev_agentd_t;
+    ')
+
+    allow $1 rhev_agentd_t:process sigchld;
+')
Index: serefpolicy-contrib-20140730/rhev.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhev.te
@@ -0,0 +1,116 @@
+policy_module(rhev,1.0)
+
+########################################
+#
+# Declarations
+#
+
+type rhev_agentd_t;
+type rhev_agentd_exec_t;
+init_daemon_domain(rhev_agentd_t, rhev_agentd_exec_t)
+
+type rhev_agentd_unit_file_t;
+systemd_unit_file(rhev_agentd_unit_file_t)
+
+type rhev_agentd_var_run_t;
+files_pid_file(rhev_agentd_var_run_t)
+
+type rhev_agentd_tmp_t;
+files_tmp_file(rhev_agentd_tmp_t)
+
+type rhev_agentd_log_t;
+logging_log_file(rhev_agentd_log_t)
+
+########################################
+#
+# rhev_agentd_t local policy
+#
+
+allow rhev_agentd_t self:capability { setuid setgid sys_nice };
+allow rhev_agentd_t self:process setsched;
+
+allow rhev_agentd_t self:fifo_file rw_fifo_file_perms;
+allow rhev_agentd_t self:unix_stream_socket create_stream_socket_perms;
+
+manage_dirs_pattern(rhev_agentd_t, rhev_agentd_var_run_t, rhev_agentd_var_run_t)
+manage_files_pattern(rhev_agentd_t, rhev_agentd_var_run_t, rhev_agentd_var_run_t)
+manage_sock_files_pattern(rhev_agentd_t, rhev_agentd_var_run_t, rhev_agentd_var_run_t)
+files_pid_filetrans(rhev_agentd_t, rhev_agentd_var_run_t, { dir file sock_file })
+
+manage_files_pattern(rhev_agentd_t, rhev_agentd_log_t, rhev_agentd_log_t)
+manage_dirs_pattern(rhev_agentd_t, rhev_agentd_log_t, rhev_agentd_log_t)
+logging_log_filetrans(rhev_agentd_t, rhev_agentd_log_t, { dir file })
+
+manage_dirs_pattern(rhev_agentd_t, rhev_agentd_tmp_t, rhev_agentd_tmp_t)
+manage_files_pattern(rhev_agentd_t, rhev_agentd_tmp_t, rhev_agentd_tmp_t)
+files_tmp_filetrans(rhev_agentd_t, rhev_agentd_tmp_t, { file dir })
+can_exec(rhev_agentd_t, rhev_agentd_tmp_t)
+
+kernel_read_system_state(rhev_agentd_t)
+kernel_read_kernel_sysctls(rhev_agentd_t)
+
+corecmd_exec_bin(rhev_agentd_t)
+corecmd_exec_shell(rhev_agentd_t)
+
+dev_read_urand(rhev_agentd_t)
+
+term_use_virtio_console(rhev_agentd_t)
+
+fs_getattr_all_fs(rhev_agentd_t)
+
+files_getattr_all_mountpoints(rhev_agentd_t)
+files_search_all_mountpoints(rhev_agentd_t)
+
+auth_use_nsswitch(rhev_agentd_t)
+
+init_read_utmp(rhev_agentd_t)
+
+libs_exec_ldconfig(rhev_agentd_t)
+logging_send_syslog_msg(rhev_agentd_t)
+
+optional_policy(`
+	rpm_read_db(rhev_agentd_t)
+	rpm_dontaudit_manage_db(rhev_agentd_t)
+')
+
+optional_policy(`
+	ssh_signull(rhev_agentd_t)
+')
+
+optional_policy(`
+    dbus_system_bus_client(rhev_agentd_t)
+    dbus_connect_system_bus(rhev_agentd_t)
+	dbus_session_bus_client(rhev_agentd_t)
+')
+
+optional_policy(`
+   xserver_dbus_chat_xdm(rhev_agentd_t)
+   xserver_stream_connect(rhev_agentd_t)
+')
+
+######################################
+#
+# rhev_agentd_t consolehelper local policy
+#
+
+optional_policy(`
+	userhelper_console_role_template(rhev_agentd, system_r, rhev_agentd_t)
+
+	allow rhev_agentd_consolehelper_t rhev_agentd_log_t:file rw_inherited_file_perms;
+	allow rhev_agentd_consolehelper_t rhev_agentd_tmp_t:file rw_inherited_file_perms;
+
+	can_exec(rhev_agentd_consolehelper_t, rhev_agentd_exec_t)
+	kernel_read_system_state(rhev_agentd_consolehelper_t)
+
+	term_use_virtio_console(rhev_agentd_consolehelper_t)
+
+	corenet_tcp_connect_xserver_port(rhev_agentd_consolehelper_t)
+
+	optional_policy(`
+		dbus_session_bus_client(rhev_agentd_consolehelper_t)
+	')
+
+	optional_policy(`
+		unconfined_dbus_chat(rhev_agentd_consolehelper_t)
+	')
+')
Index: serefpolicy-contrib-20140730/rhgb.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rhgb.if
+++ serefpolicy-contrib-20140730/rhgb.if
@@ -1,4 +1,4 @@
-## <summary> Red Hat Graphical Boot.</summary>
+## <summary> Red Hat Graphical Boot </summary>
 
 ########################################
 ## <summary>
@@ -18,7 +18,7 @@ interface(`rhgb_stub',`
 
 ########################################
 ## <summary>
-##	Inherit and use rhgb file descriptors.
+##	Use a rhgb file descriptor.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -54,7 +54,7 @@ interface(`rhgb_getpgid',`
 
 ########################################
 ## <summary>
-##	Send generic signals to rhgb.
+##	Send a signal to rhgb.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -72,8 +72,7 @@ interface(`rhgb_signal',`
 
 ########################################
 ## <summary>
-##	Read and write inherited rhgb unix
-##	domain stream sockets.
+##	Read and write to unix stream sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -110,8 +109,7 @@ interface(`rhgb_dontaudit_rw_stream_sock
 
 ########################################
 ## <summary>
-##	Connected to rhgb with a unix
-##	domain stream socket.
+##	Connected to rhgb unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -121,11 +119,10 @@ interface(`rhgb_dontaudit_rw_stream_sock
 #
 interface(`rhgb_stream_connect',`
 	gen_require(`
-		type rhgb_t, rhgb_tmpfs_t;
+		type rhgb_t;
 	')
 
-	fs_search_tmpfs($1)
-	stream_connect_pattern($1, rhgb_tmpfs_t, rhgb_tmpfs_t, rhgb_t)
+	allow $1 rhgb_t:unix_stream_socket connectto;
 ')
 
 ########################################
@@ -148,7 +145,7 @@ interface(`rhgb_rw_shm',`
 
 ########################################
 ## <summary>
-##	Read and write rhgb pty devices.
+##	Read from and write to the rhgb devpts.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -161,14 +158,12 @@ interface(`rhgb_use_ptys',`
 		type rhgb_devpts_t;
 	')
 
-	dev_list_all_dev_nodes($1)
 	allow $1 rhgb_devpts_t:chr_file rw_term_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write rhgb pty devices.
+##	dontaudit Read from and write to the rhgb devpts.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -186,7 +181,7 @@ interface(`rhgb_dontaudit_use_ptys',`
 
 ########################################
 ## <summary>
-##	Read and write to rhgb tmpfs files.
+##	Read and write to rhgb temporary file system.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -199,7 +194,6 @@ interface(`rhgb_rw_tmpfs_files',`
 		type rhgb_tmpfs_t;
 	')
 
-
 	fs_search_tmpfs($1)
 	allow $1 rhgb_tmpfs_t:file rw_file_perms;
 ')
Index: serefpolicy-contrib-20140730/rhgb.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rhgb.te
+++ serefpolicy-contrib-20140730/rhgb.te
@@ -43,7 +43,6 @@ kernel_read_system_state(rhgb_t)
 corecmd_exec_bin(rhgb_t)
 corecmd_exec_shell(rhgb_t)
 
-corenet_all_recvfrom_unlabeled(rhgb_t)
 corenet_all_recvfrom_netlabel(rhgb_t)
 corenet_tcp_sendrecv_generic_if(rhgb_t)
 corenet_tcp_sendrecv_generic_node(rhgb_t)
@@ -57,11 +56,9 @@ dev_read_urand(rhgb_t)
 
 domain_use_interactive_fds(rhgb_t)
 
-files_read_etc_files(rhgb_t)
 files_read_var_files(rhgb_t)
 files_read_etc_runtime_files(rhgb_t)
 files_search_tmp(rhgb_t)
-files_read_usr_files(rhgb_t)
 files_mounton_mnt(rhgb_t)
 files_dontaudit_rw_root_dir(rhgb_t)
 files_dontaudit_read_default_files(rhgb_t)
@@ -89,7 +86,6 @@ libs_read_lib_files(rhgb_t)
 
 logging_send_syslog_msg(rhgb_t)
 
-miscfiles_read_localization(rhgb_t)
 miscfiles_read_fonts(rhgb_t)
 miscfiles_dontaudit_write_fonts(rhgb_t)
 
Index: serefpolicy-contrib-20140730/rhnsd.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhnsd.fc
@@ -0,0 +1,9 @@
+/etc/rc\.d/init\.d/rhnsd	--	gen_context(system_u:object_r:rhnsd_initrc_exec_t,s0)
+
+/usr/lib/systemd/system/rhnsd.* --  gen_context(system_u:object_r:rhnsd_unit_file_t,s0)
+
+/usr/sbin/rhnsd		--	gen_context(system_u:object_r:rhnsd_exec_t,s0)
+
+/var/run/rhnsd\.pid		--	gen_context(system_u:object_r:rhnsd_var_run_t,s0)
+
+/etc/sysconfig/rhn(/.*)?		gen_context(system_u:object_r:rhnsd_conf_t,s0)
Index: serefpolicy-contrib-20140730/rhnsd.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhnsd.if
@@ -0,0 +1,118 @@
+## <summary>policy for rhnsd</summary>
+
+########################################
+## <summary>
+##	Transition to rhnsd.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`rhnsd_domtrans',`
+	gen_require(`
+		type rhnsd_t, rhnsd_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, rhnsd_exec_t, rhnsd_t)
+')
+
+########################################
+## <summary>
+##	Execute rhnsd server in the rhnsd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rhnsd_initrc_domtrans',`
+	gen_require(`
+		type rhnsd_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, rhnsd_initrc_exec_t)
+')
+
+########################################
+## <summary>
+##	Execute rhnsd server in the rhnsd domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`rhnsd_systemctl',`
+	gen_require(`
+		type rhnsd_t;
+		type rhnsd_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+    systemd_read_fifo_file_passwd_run($1)
+	allow $1 rhnsd_unit_file_t:file read_file_perms;
+	allow $1 rhnsd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, rhnsd_t)
+')
+
+######################################
+## <summary>
+## Allow the specified domain to manage
+## rhnsd configuration files.
+## </summary>
+## <param name="domain">
+## <summary>
+## Domain allowed access.
+## </summary>
+## </param>
+#
+interface(`rhnsd_manage_config',`
+    gen_require(`
+        type rhnsd_conf_t;
+    ')
+
+    files_search_etc($1)
+    manage_files_pattern( $1, rhnsd_conf_t, rhnsd_conf_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an rhnsd environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	Role allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`rhnsd_admin',`
+	gen_require(`
+		type rhnsd_t;
+		type rhnsd_initrc_exec_t;
+	')
+
+	allow $1 rhnsd_t:process { ptrace signal_perms };
+	ps_process_pattern($1, rhnsd_t)
+
+	rhnsd_initrc_domtrans($1)
+	domain_system_change_exemption($1)
+	role_transition $2 rhnsd_initrc_exec_t system_r;
+	allow $2 system_r;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/rhnsd.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rhnsd.te
@@ -0,0 +1,47 @@
+policy_module(rhnsd, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type rhnsd_t;
+type rhnsd_exec_t;
+init_daemon_domain(rhnsd_t, rhnsd_exec_t)
+
+type rhnsd_var_run_t;
+files_pid_file(rhnsd_var_run_t)
+
+type rhnsd_initrc_exec_t;
+init_script_file(rhnsd_initrc_exec_t)
+
+type rhnsd_unit_file_t;
+systemd_unit_file(rhnsd_unit_file_t)
+
+type rhnsd_conf_t;
+files_config_file(rhnsd_conf_t)
+
+########################################
+#
+# rhnsd local policy
+#
+
+allow rhnsd_t self:capability { kill };
+allow rhnsd_t self:process { fork signal };
+allow rhnsd_t self:fifo_file rw_fifo_file_perms;
+allow rhnsd_t self:unix_stream_socket create_stream_socket_perms;
+
+manage_dirs_pattern(rhnsd_t, rhnsd_var_run_t, rhnsd_var_run_t)
+manage_files_pattern(rhnsd_t, rhnsd_var_run_t, rhnsd_var_run_t)
+files_pid_filetrans(rhnsd_t, rhnsd_var_run_t, { dir file })
+
+manage_files_pattern(rhnsd_t, rhnsd_conf_t, rhnsd_conf_t)
+
+corecmd_exec_bin(rhnsd_t)
+
+logging_send_syslog_msg(rhnsd_t)
+
+optional_policy(`
+    # execute rhn_check
+    rpm_domtrans(rhnsd_t)
+')
